<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button>
            <!-- <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button> -->
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
            <el-select
                v-model="status"
                multiple
                clearable
                @change="getData"
                placeholder="请选择订单状态"
                class="filter-item"
            >
                <el-option v-for="item in statusOptions" :key="item.value" :value="item.value" :label="item.label">
                </el-option>
            </el-select>
            <el-select v-model="packageId" class="filter-item" clearable @change="getData" placeholder="请选择套餐">
                <el-option v-for="item in packages" :label="item.name" :value="item.id" :key="item.id"></el-option>
            </el-select>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!--<el-table-column prop="id" label="ID" width="100"> </el-table-column>-->
            <el-table-column prop="orderNumber" label="订单号" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="user.nickname" label="昵称"> </el-table-column>
            <el-table-column prop="payMethod" label="支付方式" :formatter="payMethodFormatter"> </el-table-column>
            <el-table-column prop="status" label="订单状态">
                <template slot-scope="{ row }">
                    <el-tag type="warning" v-if="row.status == 'UNPAID'">未支付</el-tag>
                    <el-tag type="success" v-else-if="row.status == 'PAID'">已支付</el-tag>
                    <el-tag type="info" v-else-if="row.status == 'CANCELLED'">已取消</el-tag>
                    <el-tag v-else>线下支付</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="name" label="名称" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="paidAt" label="支付时间" show-overflow-tooltip> </el-table-column>
            <!--<el-table-column prop="setId" label="充值套餐"> </el-table-column>-->
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <!-- <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button> -->
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'OrderInfoList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/orderInfo/backAll',
            downloading: false,
            payMethodOptions: [
                { label: '微信', value: 'WEIXIN' },
                { label: '余额', value: 'YUE' },
                { label: '线下', value: 'OFFLINE' }
            ],
            statusOptions: [
                { label: '未支付', value: 'UNPAID' },
                { label: '已支付', value: 'PAID' },
                { label: '已取消', value: 'CANCELLED' },
                { label: '线下支付', value: 'OFFLINE_PAID' }
            ],
            status: [],
            packageId: '',
            packages: []
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    mounted() {
        this.$http
            .get('/package/allList')
            .then(res => {
                this.packages = res;
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    methods: {
        payMethodFormatter(row, column, cellValue, index) {
            let selectedOption = this.payMethodOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                search: this.search,
                query: {
                    status: this.status,
                    packageId: this.packageId
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/orderInfoEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/orderInfoEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/orderInfo/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/orderInfo/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
